%define contentdir /var/www
%define subname apache2

Summary: An embedded Perl interpreter for the Apache Web server.
Name: mod_perl-%{subname}
Version: 2.0.1
Release: 1.norlug
Group: System Environment/Daemons
Source: http://perl.apache.org/dist/mod_perl-2.0-current.tar.gz
Source1: perl.conf
Source2: filter-requires.sh
Source3: reap-stale-servers.sh
Source4: testlock.sh
Patch0: beta-version.patch
License: GPL
URL: http://perl.apache.org/
BuildRoot: %{_tmppath}/%{name}-root
Requires: httpd >= 2.0.40, perl >= 5.6
BuildPrereq: httpd-devel >= 2.0.45-14, httpd, perl >= 5.6, gdbm-devel
BuildPrereq: apr-devel, apr-util-devel, perl-Cwd
Prereq: perl
Requires: httpd-mmn = 20020903, httpd => 2.0.40, perl-Cwd
Obsoletes: mod_perl
Epoch: 2

%define __perl_requires %{SOURCE2}

%description
Mod_perl incorporates a Perl interpreter into the Apache web server,
so that the Apache web server can directly execute Perl code.
Mod_perl links the Perl runtime library into the Apache web server and
provides an object-oriented Perl interface for Apache's C language
API.  The end result is a quicker CGI script turnaround process, since
no external Perl interpreter has to be started.

Install mod_perl if you're installing the Apache web server and you'd
like for it to directly incorporate a Perl interpreter.

%package devel
Summary: Files needed for building XS modules that use mod_perl
Group: Development/Libraries
Requires: mod_perl-%{subname} = %{version}-%{release}, httpd-devel

%description devel 
The mod_perl-devel package contains the files needed for building XS
modules that use mod_perl.

%prep
%setup -q -n mod_perl-%{version}
#%patch0 -p0

%build
%{__perl} Makefile.PL </dev/null \
	PREFIX=$RPM_BUILD_ROOT/usr INSTALLDIRS=vendor \
	MP_APXS=%{_sbindir}/apxs MP_APR_CONFIG=%{_bindir}/apr-config \
	CCFLAGS="$RPM_OPT_FLAGS -fPIC"
make

# Run the test suite.
#  Need to make t/htdocs/perlio because it isn't expecting to be run as
#  root and will fail tests that try and write files because the server
#  will have changed it's uid.
%ifarch 1386
mkdir t/htdocs/perlio
chmod 777 t/htdocs/perlio
$RPM_SOURCE_DIR/testlock.sh acquire
$RPM_SOURCE_DIR/reap-stale-servers.sh
make test
$RPM_SOURCE_DIR/testlock.sh release
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules
make install \
    MODPERL_AP_LIBEXECDIR=$RPM_BUILD_ROOT%{_libdir}/httpd/modules \
    MODPERL_AP_INCLUDEDIR=$RPM_BUILD_ROOT%{_includedir}/httpd

# Fix permissions of solibs to avoid strip failures on non-root builds.
find $RPM_BUILD_ROOT%{_libdir} -name "*.so" | xargs chmod u+w

# Install the config file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
install -m 644 $RPM_SOURCE_DIR/perl.conf \
   $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/

# Install its manual.
#mkdir -p $RPM_BUILD_ROOT%{contentdir}/manual/mod/mod_perl
#install -c -m 644 htdocs/manual/mod/mod_perl.html \
#        $RPM_BUILD_ROOT%{contentdir}/manual/mod

#make -C faq
#rm faq/pod2htm*
#install -m644 faq/*.html $RPM_BUILD_ROOT%{contentdir}/manual/mod/mod_perl/

# Remove the temporary files.
find $RPM_BUILD_ROOT%{_libdir}/perl?/vendor_perl/*/*/auto -name "*.bs" | xargs rm
rm -f $RPM_BUILD_ROOT%{_libdir}/perl?/vendor_perl/*/*/perllocal.pod
rm -f $RPM_BUILD_ROOT%{_libdir}/perl?/*/*/perllocal.pod

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc Changes INSTALL LICENSE README docs
#%{contentdir}/manual/mod/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf
%{_bindir}/*
%{_libdir}/httpd/modules/mod_perl.so
%{_libdir}/perl?/vendor_perl/*/*/auto/*
%{_libdir}/perl?/vendor_perl/*/*/Apache
%{_libdir}/perl?/vendor_perl/*/*/Bundle/*
%{_libdir}/perl?/vendor_perl/*/*/APR
%{_libdir}/perl?/vendor_perl/*/*/ModPerl
%{_libdir}/perl?/vendor_perl/*/*/*.pm
%{_mandir}/*/*.3*

%files devel
%defattr(-,root,root)
%{_includedir}/httpd/*

%changelog
* Sat Sep 2 2005 Chip Cuccio <chipster@norlug.org> 2.0.1-1
- updated to 2.0.1

* Fri May 20 2005 Chip Cuccio <chipster@norlug.org> 2.0.0-1
- 2.0.0 finally released to the world...finally.

* Fri Apr 22 2005 Chip Cuccio <chipster@norlug.org> 2.0.0_RC5-2
- updated to 2.0.0_RC5

* Tue Feb 8 2005 Chip Cuccio <chipster@norlug.org> 2.0.0_RC4-2
- updated

* Sun Jan 7 2005 Chip Cuccio <chipster@norlug.org> 2.0.0_RC3-2
- updated

* Mon Jan 3 2005 Chip Cuccio <chipster@norlug.org> 2.0.0_RC2-2
- updated to 2.0 RC2

* Fri Oct 22 2004 Chip Cuccio <chipster@norlug.org> 1.99_17-1
- updated

* Sun Oct 10 2004 Chip Cuccio <chipster@norlug.org> 1.99_16-2
- fixed obsoletes field.

* Tue Aug 24 2004 Chip Cuccio <chipster@norlug.org> 1.99_16-1
- updated

* Wed Jun 23 2004 Chip Cuccio <chipster@norlug.org> 1.99_14-1
- updated

* Sat Mar 20 2004 Chip Cuccio <chipster@norlug.org> 1.99_13-1
- update to 1.99_13

* Fri Feb 27 2004 Chip Cuccio <chipster@norlug.org> 1.99_12-4
- update to 1.99_12

* Sun Dec 21 2003 Chip Cuccio <chipster@norlug.org> 1.99_11-4
- initial build for rh-7.3
